#include "StopAndWaitCullingManager.h"
#include <OgreLogManager.h>

namespace GtpVisibility {

//-----------------------------------------------------------------------
void StopAndWaitCullingManager::RenderScene()
{
	//InitFrame();
	
	while (!mHierarchyInterface->GetQueue()->empty())
	{
		HierarchyNode *node = mHierarchyInterface->GetQueue()->top();
		mHierarchyInterface->GetQueue()->pop();
			
		// interesting for visualization purpose
		mHierarchyInterface->SetNodeVisible(node, false);
		mHierarchyInterface->SetLastVisited(node, mHierarchyInterface->GetFrameId());

		bool intersects = false;

		if (!mHierarchyInterface->CheckFrustumVisible(node, intersects))
		{//if (mHierarchyInterface->mIsShadowPass)
			mNumFrustumCulledNodes ++;
			if (mVisualizeCulledNodes)
			{
				mHierarchyInterface->VisualizeCulledNode(node, FRUSTUM_CULLED);
			}
		}
		else
		{
			// if intersects near plane => skip occlusion query because wrong results possible
			if (intersects)
			{
	            mHierarchyInterface->SetNodeVisible(node, true);
				mHierarchyInterface->TraverseNode(node);
				continue;
			}

			mNumQueriesIssued ++;

			unsigned int visiblePixels = 0;

			mHierarchyInterface->IssueOcclusionQuery(node)->GetQueryResult(visiblePixels, true);
			
			// node visible
			if (visiblePixels > mVisibilityThreshold)
			{
				mHierarchyInterface->TraverseNode(node);
			}
			else
			{	//if (mHierarchyInterface->mIsShadowPass)
				mNumQueryCulledNodes ++;
				if (mVisualizeCulledNodes)
				{
					mHierarchyInterface->VisualizeCulledNode(node, QUERY_CULLED);
				}
			}
		}
	}
}
} // namespace GtpVisibility
